-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Diagram - Advanced Data Binding
The JavaScript Diagram component accepts functions as expression property values. It allows you to implement custom logic when you bind a diagram to a data source.
In this demo, the nodes and edges collections are bound to a data source. Custom functions are used to get different shape types and font styles for items based on additional data source information.
The autoLayout property specifies an auto-layout algorithm type and orientation that the component uses to build diagrams.
Backend API
$(() => {
$('#diagram').dxDiagram({
nodes: {
dataSource: new DevExpress.data.ArrayStore({
key: 'id',
data: orgItems,
}),
typeExpr: itemTypeExpr,
textExpr: 'name',
widthExpr: itemWidthExpr,
heightExpr: itemHeightExpr,
textStyleExpr: itemTextStyleExpr,
styleExpr: itemStyleExpr,
autoLayout: {
type: 'tree',
orientation: 'horizontal',
},
},
edges: {
dataSource: new DevExpress.data.ArrayStore({
key: 'id',
data: orgLinks,
}),
styleExpr: linkStyleExpr,
fromLineEndExpr: linkFromLineEndExpr,
toLineEndExpr: linkToLineEndExpr,
},
toolbox: {
groups: ['general'],
},
});
function itemTypeExpr(obj, value) {
if (value) {
obj.type = (value === 'rectangle') ? undefined : 'group';
return null;
}
return obj.type === 'group' ? 'ellipse' : 'rectangle';
}
function itemWidthExpr(obj, value) {
if (value) {
obj.width = value;
return null;
}
return obj.width || (obj.type === 'group' && 1.5) || 1;
}
function itemHeightExpr(obj, value) {
if (value) {
obj.height = value;
return null;
}
return obj.height || (obj.type === 'group' && 1) || 0.75;
}
function itemTextStyleExpr(obj) {
if (obj.level === 'senior') { return { 'font-weight': 'bold', 'text-decoration': 'underline' }; }
return {};
}
function itemStyleExpr(obj) {
const style = { stroke: '#444444' };
if (obj.type === 'group') { style.fill = '#f3f3f3'; }
return style;
}
function linkStyleExpr() {
return { stroke: '#444444' };
}
function linkFromLineEndExpr() {
return 'none';
}
function linkToLineEndExpr() {
return 'none';
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/dx-diagram.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="diagram"> </div>
</div>
</body>
</html>
#diagram {
height: 900px;
}
const orgItems = [
{
id: '106',
name: 'Development',
type: 'group',
},
{
id: '107',
name: 'WinForms\nTeam',
type: 'group',
},
{
id: '108',
name: 'WPF\nTeam',
type: 'group',
},
{
id: '109',
name: 'Javascript\nTeam',
type: 'group',
},
{
id: '110',
name: 'ASP.NET\nTeam',
type: 'group',
},
{
id: '112',
name: 'Ana\nTrujillo',
level: 'senior',
},
{
id: '113',
name: 'Antonio\nMoreno',
},
{
id: '115',
name: 'Christina\nBerglund',
},
{
id: '116',
name: 'Hanna\nMoos',
},
{
id: '119',
name: 'Laurence\nLebihan',
},
{
id: '120',
name: 'Elizabeth\nLincoln',
level: 'senior',
},
{
id: '122',
name: 'Patricio\nSimpson',
level: 'senior',
},
{
id: '123',
name: 'Francisco\nChang',
},
];
const orgLinks = [
{
id: '124',
from: '106',
to: '108',
},
{
id: '125',
from: '106',
to: '109',
},
{
id: '126',
from: '106',
to: '107',
},
{
id: '127',
from: '106',
to: '110',
},
{
id: '129',
from: '110',
to: '112',
},
{
id: '130',
from: '110',
to: '113',
},
{
id: '132',
from: '107',
to: '115',
},
{
id: '133',
from: '107',
to: '116',
},
{
id: '136',
from: '108',
to: '119',
},
{
id: '137',
from: '108',
to: '120',
},
{
id: '139',
from: '109',
to: '122',
},
{
id: '140',
from: '109',
to: '123',
},
];

Backend API
<dx-diagram #diagram id="diagram">
<dxo-diagram-nodes
[dataSource]="orgItemsDataSource"
keyExpr="ID"
[typeExpr]="itemTypeExpr"
textExpr="Name"
[widthExpr]="itemWidthExpr"
[heightExpr]="itemHeightExpr"
[textStyleExpr]="itemTextStyleExpr"
[styleExpr]="itemStyleExpr"
>
<dxo-diagram-auto-layout
type="tree"
orientation="horizontal"
></dxo-diagram-auto-layout>
</dxo-diagram-nodes>
<dxo-diagram-edges
[dataSource]="orgLinksDataSource"
keyExpr="ID"
fromExpr="From"
toExpr="To"
[styleExpr]="linkStyleExpr"
[fromLineEndExpr]="linkFromLineEndExpr"
[toLineEndExpr]="linkToLineEndExpr"
></dxo-diagram-edges>
<dxo-diagram-toolbox>
<dxi-diagram-group category="general" title="General"></dxi-diagram-group>
</dxo-diagram-toolbox>
</dx-diagram>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { provideHttpClient, withFetch } from '@angular/common/http';
import { DxDiagramModule } from 'devextreme-angular';
import { ArrayStore } from 'devextreme-angular/common/data';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxDiagramModule,
],
})
export class AppComponent {
orgItemsDataSource: ArrayStore;
orgLinksDataSource: ArrayStore;
constructor(service: Service) {
this.orgItemsDataSource = new ArrayStore({
key: 'ID',
data: service.getOrgItems(),
});
this.orgLinksDataSource = new ArrayStore({
key: 'ID',
data: service.getOrgLinks(),
});
}
itemTypeExpr(obj, value) {
if (value) {
obj.Type = (value === 'rectangle') ? undefined : 'group';
return null;
}
return obj.Type === 'group' ? 'ellipse' : 'rectangle';
}
itemWidthExpr(obj, value) {
if (value) {
obj.Width = value;
return null;
}
return obj.Width || (obj.Type === 'group' && 1.5) || 1;
}
itemHeightExpr(obj, value) {
if (value) {
obj.Height = value;
return null;
}
return obj.Height || (obj.Type === 'group' && 1) || 0.75;
}
itemTextStyleExpr(obj) {
if (obj.Level === 'senior') { return { 'font-weight': 'bold', 'text-decoration': 'underline' }; }
return {};
}
itemStyleExpr(obj) {
const style: Record<string, string> = { stroke: '#444444' };
if (obj.Type === 'group') { style.fill = '#f3f3f3'; }
return style;
}
linkStyleExpr() {
return { stroke: '#444444' };
}
linkFromLineEndExpr() {
return 'none';
}
linkToLineEndExpr() {
return 'none';
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #diagram {
height: 900px;
}
import { Injectable } from '@angular/core';
export class OrgItem {
ID: string;
Name: string;
Type?: string;
Level?: string;
}
export class OrgLink {
ID: string;
From: string;
To: string;
}
const orgItems: OrgItem[] = [
{
ID: '106',
Name: 'Development',
Type: 'group',
},
{
ID: '107',
Name: 'WinForms\nTeam',
Type: 'group',
},
{
ID: '108',
Name: 'WPF\nTeam',
Type: 'group',
},
{
ID: '109',
Name: 'Javascript\nTeam',
Type: 'group',
},
{
ID: '110',
Name: 'ASP.NET\nTeam',
Type: 'group',
},
{
ID: '112',
Name: 'Ana\nTrujillo',
Level: 'senior',
},
{
ID: '113',
Name: 'Antonio\nMoreno',
},
{
ID: '115',
Name: 'Christina\nBerglund',
},
{
ID: '116',
Name: 'Hanna\nMoos',
},
{
ID: '119',
Name: 'Laurence\nLebihan',
},
{
ID: '120',
Name: 'Elizabeth\nLincoln',
Level: 'senior',
},
{
ID: '122',
Name: 'Patricio\nSimpson',
Level: 'senior',
},
{
ID: '123',
Name: 'Francisco\nChang',
},
];
const orgLinks: OrgLink[] = [
{
ID: '124',
From: '106',
To: '108',
},
{
ID: '125',
From: '106',
To: '109',
},
{
ID: '126',
From: '106',
To: '107',
},
{
ID: '127',
From: '106',
To: '110',
},
{
ID: '129',
From: '110',
To: '112',
},
{
ID: '130',
From: '110',
To: '113',
},
{
ID: '132',
From: '107',
To: '115',
},
{
ID: '133',
From: '107',
To: '116',
},
{
ID: '136',
From: '108',
To: '119',
},
{
ID: '137',
From: '108',
To: '120',
},
{
ID: '139',
From: '109',
To: '122',
},
{
ID: '140',
From: '109',
To: '123',
},
];
@Injectable()
export class Service {
getOrgItems() {
return orgItems;
}
getOrgLinks() {
return orgLinks;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React from 'react';
import Diagram, {
Nodes, AutoLayout, Edges, Toolbox, Group,
} from 'devextreme-react/diagram';
import { ArrayStore } from 'devextreme-react/common/data';
import service from './data.ts';
const orgItemsDataSource = new ArrayStore({
key: 'id',
data: service.getOrgItems(),
});
const orgLinksDataSource = new ArrayStore({
key: 'id',
data: service.getOrgLinks(),
});
function itemTypeExpr(obj: { type: string | undefined; }, value: string) {
if (value) {
obj.type = (value === 'rectangle') ? undefined : 'group';
return null;
}
return obj.type === 'group' ? 'ellipse' : 'rectangle';
}
function itemWidthExpr(obj: { width: number; type: string; }, value: number) {
if (value) {
obj.width = value;
return null;
}
return obj.width || (obj.type === 'group' && 1.5) || 1;
}
function itemHeightExpr(obj: { height: number; type: string; }, value: number) {
if (value) {
obj.height = value;
return null;
}
return obj.height || (obj.type === 'group' && 1) || 0.75;
}
function itemTextStyleExpr(obj: { level: string; }) {
if (obj.level === 'senior') {
return { 'font-weight': 'bold', 'text-decoration': 'underline' };
}
return {};
}
function itemStyleExpr(obj: { type: string; }) {
const style: { stroke: string; fill?: string } = { stroke: '#444444' };
if (obj.type === 'group') {
style.fill = '#f3f3f3';
}
return style;
}
function linkStyleExpr() {
return { stroke: '#444444' };
}
function linkFromLineEndExpr() {
return 'none';
}
function linkToLineEndExpr() {
return 'none';
}
export default function App() {
return (
<Diagram id="diagram">
<Nodes
dataSource={orgItemsDataSource}
typeExpr={itemTypeExpr}
textExpr="name"
widthExpr={itemWidthExpr}
heightExpr={itemHeightExpr}
textStyleExpr={itemTextStyleExpr}
styleExpr={itemStyleExpr}>
<AutoLayout type="tree" orientation="horizontal" />
</Nodes>
<Edges dataSource={orgLinksDataSource} styleExpr={linkStyleExpr}
fromLineEndExpr={linkFromLineEndExpr} toLineEndExpr={linkToLineEndExpr} />
<Toolbox>
<Group category="general" title="General" />
</Toolbox>
</Diagram>
);
}
import React from 'react';
import Diagram, {
Nodes, AutoLayout, Edges, Toolbox, Group,
} from 'devextreme-react/diagram';
import { ArrayStore } from 'devextreme-react/common/data';
import service from './data.js';
const orgItemsDataSource = new ArrayStore({
key: 'id',
data: service.getOrgItems(),
});
const orgLinksDataSource = new ArrayStore({
key: 'id',
data: service.getOrgLinks(),
});
function itemTypeExpr(obj, value) {
if (value) {
obj.type = value === 'rectangle' ? undefined : 'group';
return null;
}
return obj.type === 'group' ? 'ellipse' : 'rectangle';
}
function itemWidthExpr(obj, value) {
if (value) {
obj.width = value;
return null;
}
return obj.width || (obj.type === 'group' && 1.5) || 1;
}
function itemHeightExpr(obj, value) {
if (value) {
obj.height = value;
return null;
}
return obj.height || (obj.type === 'group' && 1) || 0.75;
}
function itemTextStyleExpr(obj) {
if (obj.level === 'senior') {
return { 'font-weight': 'bold', 'text-decoration': 'underline' };
}
return {};
}
function itemStyleExpr(obj) {
const style = { stroke: '#444444' };
if (obj.type === 'group') {
style.fill = '#f3f3f3';
}
return style;
}
function linkStyleExpr() {
return { stroke: '#444444' };
}
function linkFromLineEndExpr() {
return 'none';
}
function linkToLineEndExpr() {
return 'none';
}
export default function App() {
return (
<Diagram id="diagram">
<Nodes
dataSource={orgItemsDataSource}
typeExpr={itemTypeExpr}
textExpr="name"
widthExpr={itemWidthExpr}
heightExpr={itemHeightExpr}
textStyleExpr={itemTextStyleExpr}
styleExpr={itemStyleExpr}
>
<AutoLayout
type="tree"
orientation="horizontal"
/>
</Nodes>
<Edges
dataSource={orgLinksDataSource}
styleExpr={linkStyleExpr}
fromLineEndExpr={linkFromLineEndExpr}
toLineEndExpr={linkToLineEndExpr}
/>
<Toolbox>
<Group
category="general"
title="General"
/>
</Toolbox>
</Diagram>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
const orgItems = [
{
id: '106',
name: 'Development',
type: 'group',
},
{
id: '107',
name: 'WinForms\nTeam',
type: 'group',
},
{
id: '108',
name: 'WPF\nTeam',
type: 'group',
},
{
id: '109',
name: 'Javascript\nTeam',
type: 'group',
},
{
id: '110',
name: 'ASP.NET\nTeam',
type: 'group',
},
{
id: '112',
name: 'Ana\nTrujillo',
level: 'senior',
},
{
id: '113',
name: 'Antonio\nMoreno',
},
{
id: '115',
name: 'Christina\nBerglund',
},
{
id: '116',
name: 'Hanna\nMoos',
},
{
id: '119',
name: 'Laurence\nLebihan',
},
{
id: '120',
name: 'Elizabeth\nLincoln',
level: 'senior',
},
{
id: '122',
name: 'Patricio\nSimpson',
level: 'senior',
},
{
id: '123',
name: 'Francisco\nChang',
},
];
const orgLinks = [
{
id: '124',
from: '106',
to: '108',
},
{
id: '125',
from: '106',
to: '109',
},
{
id: '126',
from: '106',
to: '107',
},
{
id: '127',
from: '106',
to: '110',
},
{
id: '129',
from: '110',
to: '112',
},
{
id: '130',
from: '110',
to: '113',
},
{
id: '132',
from: '107',
to: '115',
},
{
id: '133',
from: '107',
to: '116',
},
{
id: '136',
from: '108',
to: '119',
},
{
id: '137',
from: '108',
to: '120',
},
{
id: '139',
from: '109',
to: '122',
},
{
id: '140',
from: '109',
to: '123',
},
];
export default {
getOrgItems() {
return orgItems;
},
getOrgLinks() {
return orgLinks;
},
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
const orgItems = [
{
id: '106',
name: 'Development',
type: 'group',
},
{
id: '107',
name: 'WinForms\nTeam',
type: 'group',
},
{
id: '108',
name: 'WPF\nTeam',
type: 'group',
},
{
id: '109',
name: 'Javascript\nTeam',
type: 'group',
},
{
id: '110',
name: 'ASP.NET\nTeam',
type: 'group',
},
{
id: '112',
name: 'Ana\nTrujillo',
level: 'senior',
},
{
id: '113',
name: 'Antonio\nMoreno',
},
{
id: '115',
name: 'Christina\nBerglund',
},
{
id: '116',
name: 'Hanna\nMoos',
},
{
id: '119',
name: 'Laurence\nLebihan',
},
{
id: '120',
name: 'Elizabeth\nLincoln',
level: 'senior',
},
{
id: '122',
name: 'Patricio\nSimpson',
level: 'senior',
},
{
id: '123',
name: 'Francisco\nChang',
},
];
const orgLinks = [
{
id: '124',
from: '106',
to: '108',
},
{
id: '125',
from: '106',
to: '109',
},
{
id: '126',
from: '106',
to: '107',
},
{
id: '127',
from: '106',
to: '110',
},
{
id: '129',
from: '110',
to: '112',
},
{
id: '130',
from: '110',
to: '113',
},
{
id: '132',
from: '107',
to: '115',
},
{
id: '133',
from: '107',
to: '116',
},
{
id: '136',
from: '108',
to: '119',
},
{
id: '137',
from: '108',
to: '120',
},
{
id: '139',
from: '109',
to: '122',
},
{
id: '140',
from: '109',
to: '123',
},
];
export default {
getOrgItems() {
return orgItems;
},
getOrgLinks() {
return orgLinks;
},
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#diagram {
height: 900px;
}

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Diagram - Advanced Data Binding
The Diagram component accepts functions as expression property values. It allows you to implement custom logic when you bind a diagram to a data source.
In this demo, the nodes and edges collections are bound to a data source. Custom functions are used to get different shape types and font styles for items based on additional data source information.
The autoLayout property specifies an auto-layout algorithm type and orientation that the component uses to build diagrams.
Backend API
<template>
<DxDiagram
id="diagram"
ref="diagram"
>
<DxNodes
:data-source="orgItemsDataSource"
:type-expr="itemTypeExpr"
:text-expr="'name'"
:width-expr="itemWidthExpr"
:height-expr="itemHeightExpr"
:text-style-expr="itemTextStyleExpr"
:style-expr="itemStyleExpr"
>
<DxAutoLayout
:type="'tree'"
:orientation="'horizontal'"
/>
</DxNodes>
<DxEdges
:data-source="orgLinksDataSource"
:from-line-end-expr="linkFromLineEndExpr"
:to-line-end-expr="linkToLineEndExpr"
:style-expr="linkStyleExpr"
/>
<DxToolbox>
<DxGroup
:category="'general'"
:title="'General'"
/>
</DxToolbox>
</DxDiagram>
</template>
<script setup lang="ts">
import {
DxDiagram, DxNodes, DxAutoLayout, DxEdges, DxToolbox, DxGroup,
} from 'devextreme-vue/diagram';
import { ArrayStore } from 'devextreme-vue/common/data';
import service from './data.ts';
const orgItemsDataSource = new ArrayStore({
key: 'id',
data: service.getOrgItems(),
});
const orgLinksDataSource = new ArrayStore({
key: 'id',
data: service.getOrgLinks(),
});
const linkStyleExpr = () => ({ stroke: '#444444' });
const linkFromLineEndExpr = () => 'none';
const linkToLineEndExpr = () => 'none';
const itemTextStyleExpr = (obj: any) => (obj.level === 'senior'
? { 'font-weight': 'bold', 'text-decoration': 'underline' }
: {}
);
const itemStyleExpr = ({ type }: { type: string }) => ({
stroke: '#444444',
...(type === 'group' ? { fill: '#f3f3f3' } : {}),
});
function itemTypeExpr(obj: any, value: any) {
if (value) {
obj.type = (value === 'rectangle') ? undefined : 'group';
return null;
}
return obj.type === 'group' ? 'ellipse' : 'rectangle';
}
function itemWidthExpr(obj: any, value: any) {
if (value) {
obj.width = value;
return null;
}
return obj.width || (obj.type === 'group' && 1.5) || 1;
}
function itemHeightExpr(obj: any, value: any) {
if (value) {
obj.height = value;
return null;
}
return obj.height || (obj.type === 'group' && 1) || 0.75;
}
</script>
<style scoped>
#diagram {
height: 900px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const orgItems = [
{
id: '106',
name: 'Development',
type: 'group',
},
{
id: '107',
name: 'WinForms\nTeam',
type: 'group',
},
{
id: '108',
name: 'WPF\nTeam',
type: 'group',
},
{
id: '109',
name: 'Javascript\nTeam',
type: 'group',
},
{
id: '110',
name: 'ASP.NET\nTeam',
type: 'group',
},
{
id: '112',
name: 'Ana\nTrujillo',
level: 'senior',
},
{
id: '113',
name: 'Antonio\nMoreno',
},
{
id: '115',
name: 'Christina\nBerglund',
},
{
id: '116',
name: 'Hanna\nMoos',
},
{
id: '119',
name: 'Laurence\nLebihan',
},
{
id: '120',
name: 'Elizabeth\nLincoln',
level: 'senior',
},
{
id: '122',
name: 'Patricio\nSimpson',
level: 'senior',
},
{
id: '123',
name: 'Francisco\nChang',
},
];
const orgLinks = [
{
id: '124',
from: '106',
to: '108',
},
{
id: '125',
from: '106',
to: '109',
},
{
id: '126',
from: '106',
to: '107',
},
{
id: '127',
from: '106',
to: '110',
},
{
id: '129',
from: '110',
to: '112',
},
{
id: '130',
from: '110',
to: '113',
},
{
id: '132',
from: '107',
to: '115',
},
{
id: '133',
from: '107',
to: '116',
},
{
id: '136',
from: '108',
to: '119',
},
{
id: '137',
from: '108',
to: '120',
},
{
id: '139',
from: '109',
to: '122',
},
{
id: '140',
from: '109',
to: '123',
},
];
export default {
getOrgItems() {
return orgItems;
},
getOrgLinks() {
return orgLinks;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>